#!/usr/bin/lua
require("lib_eor3d_lua")

-- printf
printf = function(s,...)
           return io.write(s:format(...))
         end -- function

-- bit
function hasbit(x, p)
  return x % (p + p) >= p
end

--round funktion
function round(num, places)
        num = tostring(num)
        local inc = false
        local decimal = string.find(num, "%.")
        if num:len() - decimal <= places then return tonumber(num) end --already rounded, nothing to do.
        local digit = tonumber(num:sub(decimal + places + 1))
        num = num:sub(1, decimal + places)
        if digit <= 4 then return tonumber(num) end --no incrementation needed, return truncated number
        local newNum = ""
        for i=num:len(), 1, -1 do
                digit = tonumber(num:sub(i))
                if digit == 9 then
                        if i > 1 then
                                newNum = "0"..newNum
                        else
                                newNum = "10"..newNum
                        end
                elseif digit == nil then
                        newNum = "."..newNum
                else
                        if i > 1 then
                                newNum = num:sub(1,i-1)..(digit + 1)..newNum
                        else
                                newNum = (digit + 1)..newNum
                        end
                        return tonumber(newNum) --No more 9s found, so we are done incrementing. Copy remaining digits, then return number.
                end
        end
        return tonumber(newNum)
end

	--
	-- SCRIPT START
	--
	printf("EOR3D U1-U3,U0 START!\n")
	--

	U1 = 0.0
	U2 = 0.0
	U3 = 0.0
	Uo = 0.0
	Uo_vergleich = 50.0
	r8 = 0.0
	
	be1pol = 0.0;
	be2pol = 0.0;
	r7 = 0.0
	be = 0;
	be1 = 0;
	be2 = 0;
	
	line = eor3d_command("E3D_U1")
	U1 = round(line,2)
	printf("U1 value: %s\n", line)
	printf("U1 round: %.2f\n",U1)

	line = eor3d_command("E3D_U2")
	U2 = round(line,2)
	printf("U2 value: %s\n", line)
	printf("U2 round: %.2f\n", U2)

	line = eor3d_command("E3D_U3")
	U3 = round(line,2)
	printf("U3 value: %s\n", line)
	printf("U3 round: %.2f\n", U3)

	line = eor3d_command("E3D_U0")
	Uo = round(line,2)
	printf("Uo value: %s\n", line)
	printf("Uo round: %.2f\n", Uo)

	printf("EOR3D U1-U3,U0 END!\n")
	--

	--Uo Test
	printf("\nEOR3D U0 check!\n")
	if Uo < Uo_vergleich then
		printf("Uo (%.2f) smaller than (%.2f)!\n", Uo, Uo_vergleich)

		--REL 8 OFF
		line = eor3d_command("E3D_BApol8")
		r8 = round(line,0)
		printf("REL 8 is: %.2f\n", r8)

		-- REL set if not the same
		if r8 == 1.0 then
			printf("REL 8 is ok, is 1\n")
		else
			eor3d_command("E3D_BApol8=1")
			eor3d_command("update")
			eor3d_command("E3D_ParamChanged=1")
		end
	else
		printf("Uo (%.2f) bigger than (%.2f)!\n", Uo, Uo_vergleich)

		--REL 8 ON
		line = eor3d_command("E3D_BApol8")
		r8 = round(line,0)
		printf("REL 8 is: %.2f\n", r8)

		-- REL set if not the same
		if r8 == 2.0 then
			printf("REL 8 is ok, is 2\n")
		else
			eor3d_command("E3D_BApol8=2")
			eor3d_command("update")
			eor3d_command("E3D_ParamChanged=1")
		end
	end
	printf("\n")

	--BE Test
	printf("EOR3D BE1,BE2!\n")

	line = eor3d_command("E3D_Y_BE")
	be = tonumber(line)
	printf("BE : dec:%d string:%s\n", be, line)
	be1 = hasbit(be, 1)
	be2 = hasbit(be, 2)

	if be1 == true then
		printf("BE1: IS ON \n")
	else
		printf("BE1: IS OFF\n")
	end

	if be2 == true then
		printf("BE2: IS ON \n")
	else
		printf("BE2: IS OFF\n")
	end
	printf("\n")

	-- warning, this always saves the parameter file, do not always save in scripts
	--print("EOR3D START SAVE !")
		--eor3d_command("save")
	--print("EOR3D END SAVE !")

	-- SCRIPT END EXIT HERE
	os.exit()

	--
	print("EOR3D REL START!")

	eor3d_command("E3D_BAassign1=1")
	eor3d_command("E3D_BAassign2=1")
	eor3d_command("E3D_BAassign3=1")
	eor3d_command("E3D_BAassign4=1")
	eor3d_command("E3D_BAassign5=1")
	eor3d_command("E3D_BAassign6=1")
	eor3d_command("E3D_BAassign7=1")
	eor3d_command("E3D_BAassign8=1")

	eor3d_command("E3D_BApol1=1")
	eor3d_command("E3D_BApol2=1")
	eor3d_command("E3D_BApol3=1")
	eor3d_command("E3D_BApol4=1")
	eor3d_command("E3D_BApol5=1")
	eor3d_command("E3D_BApol6=1")
	eor3d_command("E3D_BApol7=1")
	eor3d_command("E3D_BApol8=1")

	eor3d_command("update")
	eor3d_command("E3D_ParamChanged=1")

	---------------
	-- R3 ... R8 ein
	print("EOR3D REL R3-R8 ON!")
	eor3d_command("E3D_BApol1=1")
	eor3d_command("E3D_BApol2=1")
	eor3d_command("E3D_BApol3=2")
	eor3d_command("E3D_BApol4=2")
	eor3d_command("E3D_BApol5=2")
	eor3d_command("E3D_BApol6=2")
	eor3d_command("E3D_BApol7=2")
	eor3d_command("E3D_BApol8=2")

	eor3d_command("update")
	eor3d_command("E3D_ParamChanged=1")

	---------------
	-- R3 ... R8 aus, R1/R2 ein 
	print("EOR3D REL R3-R8 OFF, R1/R2 ON!")
	eor3d_command("E3D_BApol1=2")
	eor3d_command("E3D_BApol2=2")
	eor3d_command("E3D_BApol3=1")
	eor3d_command("E3D_BApol4=1")
	eor3d_command("E3D_BApol5=1")
	eor3d_command("E3D_BApol6=1")
	eor3d_command("E3D_BApol7=1")
	eor3d_command("E3D_BApol8=1")

	eor3d_command("update")
	eor3d_command("E3D_ParamChanged=1")

	----------------
	-- R1/R2 aus
	print("EOR3D REL R3-R8 OFF, R1/R2 OFF!")
	eor3d_command("E3D_BApol1=1")
	eor3d_command("E3D_BApol2=1")
	eor3d_command("E3D_BApol3=1")
	eor3d_command("E3D_BApol4=1")
	eor3d_command("E3D_BApol5=1")
	eor3d_command("E3D_BApol6=1")
	eor3d_command("E3D_BApol7=1")
	eor3d_command("E3D_BApol8=1")

	eor3d_command("update")
	eor3d_command("E3D_ParamChanged=1")

	print("EOR3D REL END!")

os.exit()
